/*
 * Copyright 2013 Victor Nazarov <asviraspossible@gmail.com>.
 */
package org.github.sviperll.stream;

import java.io.Closeable;
import java.io.IOException;

/**
 *
 * @author Victor Nazarov <asviraspossible@gmail.com>
 */
public class CloseableStream<T> implements Closeable {
    private Stream<T> stream;
    private Closeable resource;
    public CloseableStream(Stream<T> stream, Closeable resource) {
        this.stream = stream;
        this.resource = resource;
    }

    @Override
    public void close() {
        try {
            resource.close();
        } catch (IOException ex) {
            throw new RuntimeException(ex);
        }
    }

    Stream<T> stream() {
        return stream;
    }
}
