/*
 * Copyright 2013 Victor Nazarov <asviraspossible@gmail.com>.
 */
package org.github.sviperll.stream;

import com.github.sviperll.InterruptableConsumer;
import com.github.sviperll.Consumer;
import com.github.sviperll.Supplier;
import java.util.Iterator;

/**
 *
 * @author Victor Nazarov <asviraspossible@gmail.com>
 */
class GeneratedStreamBehaviour<T> implements StreamBehaviour<T> {
    private final Supplier<T> supplier;

    public GeneratedStreamBehaviour(Supplier<T> supplier) {
        this.supplier = supplier;
    }

    @Override
    public Iterator<T> openIterator() {
        return new Iterator<T>() {
            @Override
            public boolean hasNext() {
                return true;
            }

            @Override
            public T next() {
                return supplier.get();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Not supported.");
            }
        };
    }

    @Override
    public void forEach(InterruptableConsumer<? super T> consumer) {
        for (;;) {
            if (!consumer.needsMore())
                break;
            consumer.accept(supplier.get());
        }
    }

}
